# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .address import Address
from .general_bank_account_payment_method import GeneralBankAccountPaymentMethod


class GenericBankAccountDetails(pydantic.BaseModel):
    """
    Model for any generic bank account
    """

    method: GeneralBankAccountPaymentMethod
    account_number: typing.Optional[str] = pydantic.Field(
        alias="accountNumber", description='Bank account number <span style="white-space: nowrap">`non-empty`</span> '
    )
    account_type: typing.Optional[str] = pydantic.Field(
        alias="accountType", description="Bank account type. E.g. Checking, Savings etc."
    )
    bank_name: typing.Optional[str] = pydantic.Field(
        alias="bankName", description='Name of the bank <span style="white-space: nowrap">`non-empty`</span> '
    )
    bank_code: typing.Optional[str] = pydantic.Field(
        alias="bankCode",
        description="Unique identifier of the bank. In some countries, this can be the same as the bank's SWIFT code",
    )
    name: typing.Optional[str] = pydantic.Field(description="Name of the account holder")
    bank_address: typing.Optional[Address] = pydantic.Field(alias="bankAddress")
    special_instructions: typing.Optional[str] = pydantic.Field(
        alias="specialInstructions", description="Special instructions to be specified if any"
    )
    payment_channel: typing.Optional[str] = pydantic.Field(alias="paymentChannel")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
